/* Microprocessors Based Design
 * Asynchronous Web Server
 *
 * Calin Cruceru <calin.cruceru@stud.acs.upb.ro>, 335CB
 *
 * API of the bytes supplier
 */

#ifndef BYTES_SUPPLY_H_
#define BYTES_SUPPLY_H_ 1

#include <stdlib.h> /* size_t */

/* The function which encapsulates random number generation.  It does so in
 * order to increase the throughput, as opposed to if the application would
 * have interacted directly with the TRNG output.
 *
 * It uses a DRBG (Deterministic Random Byte Generator) in order to increase
 * the throughput.
 *
 * Returns 0 on success and -1 on error.
 */
extern int get_random_bytes(unsigned char *output, size_t output_len);

#endif /* BYTES_SUPPLY_H_ */

