/* Microprocessors Based Design
 * Asynchronous Web Server
 *
 * Calin Cruceru <calin.cruceru@stud.acs.upb.ro>, 335CB
 *
 * Translation unit which implements the `connection` data type API functions.
 */

#include "connection.h"
#include "error_handling.h"
#include "sock_util.h"

#include <stdlib.h>

/* Free the memory allocated for the given connection */
void conn_free(struct connection *conn)
{
	DIE(!(conn->state == STATE_CONNECTION_ENDED ||
	      conn->state == STATE_CONNECTION_ERROR), "conn_free invariant");

	tcp_close_connection(conn->sockfd);
	free(conn);
}

struct connection *conn_new(int sockfd)
{
	struct connection *conn;

	conn = malloc(sizeof(*conn));
	DIE(conn == NULL, "malloc");

	conn->state = STATE_RECEIVING_DATA;
	conn->sockfd = sockfd;
	conn->inoff = 0;

	return conn;
}

