/* Microprocessors Based Design
 * Asynchronous Web Server
 *
 * Calin Cruceru <calin.cruceru@stud.acs.upb.ro>, 335CB
 *
 * Utility functions which use the http_parser lib.
 */

#ifndef HTTP_UTIL_H_
#define HTTP_UTIL_H_ 1

#include <stdio.h> /* BUFSIZ */

/* maximum size of a path in a http request */
#define MAX_PATH_SIZE	BUFSIZ

/* Extracts the path requested through a HTTP GET.  The @http_req param is the
 * full HTTP request and the @out_buffer is the buffer used to store the
 * requested path.
 *
 * NOTE: This function is not thread-safe!
 */
extern void extract_path(const char *http_req, char out_buffer[MAX_PATH_SIZE]);

#endif /* HTTP_UTIL_H_ */

