#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

#include <stdio.h>

#include "error_handling.h"


#define KB (1 << 10)
#define MB (1 << 20)
#define BYTES_COUNT (100 * KB)

#define DEVICE_NAME "/dev/ttyUSB0"
#define DATA_FILE "output.dat"

unsigned char bytes[BYTES_COUNT];

int main(void)
{
	int in_fd, out_fd;
	int bytes_read, ret;

	in_fd = open(DEVICE_NAME, O_RDONLY | O_NOCTTY);
	DIE(in_fd < 0, "open");

	for (bytes_read = 0; bytes_read < BYTES_COUNT; bytes_read += ret) {
		/* Print status */
		printf("\r%d/%d", bytes_read, BYTES_COUNT);

		ret = read(in_fd, bytes + bytes_read,
			   BYTES_COUNT - bytes_read);
		DIE(ret < 0, "read");
	}
	DIE(close(in_fd), "close");

	printf("\nWriting data to output file... ");

	out_fd = open(DATA_FILE, O_WRONLY | O_CREAT | O_TRUNC, 0644);
	DIE(out_fd < 0, "open");

	for (bytes_read = 0; bytes_read < BYTES_COUNT; bytes_read += ret) {
		ret = write(out_fd, bytes + bytes_read,
			    BYTES_COUNT - bytes_read);
		DIE(ret < 0, "write");
	}

	printf("Done\n");
	DIE(close(out_fd), "close");

	return 0;
}

