#include <stdio.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "error_handling.h"

#define DATA_FILE "output.dat"

int main(void)
{
	int fd;
	unsigned int total_bytes = 0;
	unsigned int freq[256] = {0};
	unsigned char byte;
	int i;
	int rc;

	fd = open(DATA_FILE, O_RDONLY);
	DIE(fd < 0, "open");

	while ((rc = read(fd, &byte, 1)) > 0) {
		DIE(rc < 0, "read");
		++freq[byte];

		++total_bytes;
	}

	for (i = 0; i < 256; ++i)
		printf("%c%d - %f", (i % 10 == 0 ? '\n' : '\t'),
				    i, freq[i] * 100. / total_bytes);
	printf("\n");

	DIE(close(fd), "close");
	return 0;
}
