/* Operating Systems 2016
 * Calin Cruceru <calin.cruceru@stud.acs.upb.ro>, 335CB
 *
 * Defines macros for error handling.
 */

#ifndef ERROR_HANDLING_H_
#define ERROR_HANDLING_H_ 1

#include <stdio.h>
#include <stdlib.h>

/* error printing macro */
#define ERR(call_description) \
	do { \
		fprintf(stderr, "(%s, %d): ", \
				__FILE__, __LINE__); \
		perror(call_description); \
	} while (0)

/* print error (call ERR) and exit */
#define DIE(assertion, call_description) \
	do { \
		if (assertion) { \
			ERR(call_description); \
			exit(EXIT_FAILURE); \
		} \
	} while (0)

/* surpress 'argument unused' warnings */
#define UNUSED(a) ((void)&a)

#endif /* ERROR_HANDLING_H_ */

